// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "Kismet/BlueprintFunctionLibrary.h"
#include "BPFL_EpicInventory.generated.h"

//Forward Declarations
class UAC_PlayerInventory;
class UAC_InventoryItem;
class UAC_PlayerStats;
/**
 * 
 */
UCLASS()
class EPIC_INVENTORY_API UBPFL_EpicInventory : public UBlueprintFunctionLibrary
{
	GENERATED_BODY()

public:

	// Get the players inventory actor component
	UFUNCTION(BlueprintCallable, Category = "Player Inventory Getters")
	static UAC_PlayerInventory* GetPlayerInventoryComponent(UObject* WorldContextObject);

	//Request interaction with the player quest component
	UFUNCTION(BlueprintCallable, Category = "Inventory Interaction")
	static void RequestInteraction(AActor* InteractingActor);

	UFUNCTION(BlueprintCallable, Category = "Player Stat Getters")
	static UAC_PlayerStats* GetPlayerStatsComponent(UObject* WorldContextObject);

	UFUNCTION(BlueprintCallable, Category = "Player Inventory Getters")
	static bool AreItemsEqual(const FBaseItemInfo& ItemA, const FBaseItemInfo& ItemB);

	
};
